diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/qos-txop.cc ns-3.31/src/wifi/model/qos-txop.cc
--- ns-3.30.1/src/wifi/model/qos-txop.cc	2019-09-18 10:36:11.000000000 -0700
+++ ns-3.31/src/wifi/model/qos-txop.cc	2020-06-27 17:38:30.000000000 -0700
@@ -1083,14 +1104,26 @@
               return;
             }
 
-          // when dequeuing the peeked packet, A-MSDU aggregation is attempted if the
-          // packet has been peeked from the EDCA queue. Thus, compute the max available
-          // time for the transmission of the PPDU
-          Time maxPpduDuration = GetTxopRemaining () - m_low->CalculateOverheadTxTime (nextFrame, params);
-          NS_ASSERT (maxPpduDuration.IsPositive ());
+          Ptr<WifiMacQueueItem> item;
+          if (nextFrame->GetHeader ().IsBlockAckReq ())
+            {
+              item = Copy (m_baManager->GetBar ());
+            }
+          // non-broadcast QoS Data frames may be sent in MU PPDUs. Given that at this stage
+          // we do not know the bandwidth it would be given nor the selected acknowledgment
+          // sequence, we cannot determine the constraints on size and duration limit. Hence,
+          // we only peek the non-broadcast QoS Data frame. MacLow will be in charge of
+          // computing the correct limits and dequeue the frame.
+          else if (nextFrame->GetHeader ().IsQosData () && !nextFrame->GetHeader ().GetAddr1 ().IsBroadcast ())
+            {
+              item = Copy (nextFrame);
+            }
+          else
+            {
+              // dequeue the peeked frame
+              item = DequeuePeekedFrame (nextFrame, m_low->GetDataTxVector (nextFrame));
+            }
 
-          Ptr<WifiMacQueueItem> item = DequeuePeekedFrame (nextFrame, m_low->GetDataTxVector (nextFrame),
-                                                          true, 0, maxPpduDuration);
           NS_ASSERT (item != 0);
           NS_LOG_DEBUG ("start next packet " << *item << " within the current TXOP");
           m_currentPacket = item->GetPacket ();
@@ -1101,15 +1134,7 @@
           m_currentParams = params;
           m_stationManager->UpdateFragmentationThreshold ();
           m_fragmentNumber = 0;
-          if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsBroadcast ())
-            {
-              VerifyBlockAck ();
-            }
           GetLow ()->StartTransmission (item, m_currentParams, this);
-          if (!GetAmpduExist (m_currentHdr.GetAddr1 ()))
-            {
-              CompleteTx ();
-            }
           return;
         }
     }
@@ -1127,10 +1152,7 @@
       NS_LOG_DEBUG ("Terminating TXOP. Duration = " << Simulator::Now () - m_startTxop);
       m_txopTrace (m_startTxop, Simulator::Now () - m_startTxop);
     }
-  m_cwTrace = GetCw ();
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
   RestartAccessIfNeeded ();
 }
 
@@ -1172,7 +1194,7 @@
                                                                WIFI_MOD_CLASS_HT) >= m_currentPacket->GetSize ()))
     {
       //MSDU is not fragmented when it is transmitted using an HT-immediate or
-      //HT-delayed Block Ack agreement or when it is carried in an A-MPDU.
+      //HT-delayed block ack agreement or when it is carried in an A-MPDU.
       return false;
     }
   bool needTxopFragmentation = false;
@@ -1416,7 +1438,6 @@
 {
   NS_LOG_FUNCTION (this << packet << &hdr);
   WifiMacTrailer fcs;
-  m_stationManager->PrepareForQueue (hdr.GetAddr1 (), &hdr, packet);
   m_queue->PushFront (Create<WifiMacQueueItem> (packet, hdr));
   StartAccessIfNeeded ();
 }
@@ -1429,6 +1450,22 @@
   if (respHdr->GetStatusCode ().IsSuccess ())
     {
       NS_LOG_DEBUG ("block ack agreement established with " << recipient);
+      // Even though a (destination, TID) pair is "blocked" (i.e., no more packets
+      // are sent) when an Add BA Request is sent to the destination,
+      // the current packet may still be non-null when the Add BA Response is received.
+      // In fact, if the Add BA Request timer expires, the (destination, TID) pair is
+      // "unblocked" and packets to the destination are sent again (under normal
+      // ack policy). Thus, there may be a packet needing to be retransmitted
+      // when the Add BA Response is received. If this is the case, let the block
+      // ack manager handle its retransmission.
+      if (m_currentPacket != 0 && m_currentHdr.IsQosData ()
+          && m_currentHdr.GetAddr1 () == recipient && m_currentHdr.GetQosTid () == tid)
+        {
+          Ptr<WifiMacQueueItem> mpdu = Create<WifiMacQueueItem> (m_currentPacket, m_currentHdr,
+                                                                 m_currentPacketTimestamp);
+          m_baManager->GetRetransmitQueue ()->Enqueue (mpdu);
+          m_currentPacket = 0;
+        }
       m_baManager->UpdateAgreement (respHdr, recipient);
     }
   else
@@ -1448,11 +1485,11 @@
 }
 
 void
-QosTxop::GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient, double rxSnr, WifiMode txMode, double dataSnr)
+QosTxop::GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient, double rxSnr, double dataSnr, WifiTxVector dataTxVector)
 {
-  NS_LOG_FUNCTION (this << blockAck << recipient << rxSnr << txMode.GetUniqueName () << dataSnr);
+  NS_LOG_FUNCTION (this << blockAck << recipient << rxSnr << dataSnr << dataTxVector);
   NS_LOG_DEBUG ("got block ack from=" << recipient);
-  m_baManager->NotifyGotBlockAck (blockAck, recipient, rxSnr, txMode, dataSnr);
+  m_baManager->NotifyGotBlockAck (blockAck, recipient, rxSnr, dataSnr, dataTxVector);
   if (!m_txOkCallback.IsNull ())
     {
       m_txOkCallback (m_currentHdr);
@@ -1461,22 +1498,6 @@
   ResetCw ();
 }
 
-void
-QosTxop::VerifyBlockAck (void)
-{
-  NS_LOG_FUNCTION (this);
-  uint8_t tid = m_currentHdr.GetQosTid ();
-  Mac48Address recipient = m_currentHdr.GetAddr1 ();
-  Ptr<const WifiMacQueueItem> item = Create<const WifiMacQueueItem> (m_currentPacket, m_currentHdr);
-  WifiModulationClass modulation = m_low->GetDataTxVector (item).GetMode ().GetModulationClass ();
-  if ((m_baManager->ExistsAgreementInState (recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
-      && (GetLow ()->GetMpduAggregator () == 0 ||
-          GetLow ()->GetMpduAggregator ()->GetMaxAmpduSize (m_currentHdr.GetAddr1 (), tid, modulation) == 0))
-    {
-      m_currentHdr.SetQosAckPolicy (WifiMacHeader::BLOCK_ACK);
-    }
-}
-
 bool QosTxop::GetAmpduExist (Mac48Address dest) const
 {
   NS_LOG_FUNCTION (this << dest);
@@ -1495,31 +1516,14 @@
 }
 
 void
-QosTxop::CompleteTx (void)
-{
-  NS_LOG_FUNCTION (this);
-  if (m_currentHdr.IsQosData () && m_currentHdr.IsQosBlockAck ())
-    {
-      if (!m_currentHdr.IsRetry ())
-        {
-          m_baManager->StorePacket (Create<WifiMacQueueItem> (m_currentPacket, m_currentHdr,
-                                                              m_currentPacketTimestamp));
-        }
-      m_baManager->NotifyMpduTransmission (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid (),
-                                           m_txMiddle->GetNextSeqNumberByTidAndAddress (m_currentHdr.GetQosTid (),
-                                                                                        m_currentHdr.GetAddr1 ()), WifiMacHeader::BLOCK_ACK);
-    }
-}
-
-void
 QosTxop::CompleteMpduTx (Ptr<WifiMacQueueItem> mpdu)
 {
   NS_ASSERT (mpdu->GetHeader ().IsQosData ());
-  m_baManager->StorePacket (mpdu);
-  m_baManager->NotifyMpduTransmission (mpdu->GetHeader ().GetAddr1 (), mpdu->GetHeader ().GetQosTid (),
-                                       m_txMiddle->GetNextSeqNumberByTidAndAddress (mpdu->GetHeader ().GetQosTid (),
-                                                                                    mpdu->GetHeader ().GetAddr1 ()),
-                                                                                    WifiMacHeader::NORMAL_ACK);
+  // If there is an established BA agreement, store the packet in the queue of outstanding packets
+  if (GetBaAgreementEstablished (mpdu->GetHeader ().GetAddr1 (), mpdu->GetHeader ().GetQosTid ()))
+    {
+      m_baManager->StorePacket (mpdu);
+    }
 }
 
 bool
@@ -1543,29 +1547,6 @@
 }
 
 void
-QosTxop::SendBlockAckRequest (const Bar &bar)
-{
-  NS_LOG_FUNCTION (this << &bar);
-  WifiMacHeader hdr;
-  hdr.SetType (WIFI_MAC_CTL_BACKREQ);
-  hdr.SetAddr1 (bar.recipient);
-  hdr.SetAddr2 (m_low->GetAddress ());
-  hdr.SetAddr3 (m_low->GetBssid ());
-  hdr.SetDsNotTo ();
-  hdr.SetDsNotFrom ();
-  hdr.SetNoRetry ();
-  hdr.SetNoMoreFragments ();
-
-  m_currentPacket = bar.bar;
-  m_currentHdr = hdr;
-
-  Ptr<WifiMacQueueItem> mpdu = Create<WifiMacQueueItem> (m_currentPacket, m_currentHdr);
-  m_currentParams = GetTransmissionParameters (mpdu);
-
-  m_low->StartTransmission (mpdu, m_currentParams, this);
-}
-
-void
 QosTxop::CompleteConfig (void)
 {
   NS_LOG_FUNCTION (this);
@@ -1606,7 +1587,7 @@
   hdr.SetType (WIFI_MAC_MGT_ACTION);
   hdr.SetAddr1 (dest);
   hdr.SetAddr2 (m_low->GetAddress ());
-  hdr.SetAddr3 (m_low->GetAddress ());
+  hdr.SetAddr3 (m_low->GetBssid ());
   hdr.SetDsNotTo ();
   hdr.SetDsNotFrom ();
 
@@ -1665,7 +1646,7 @@
   hdr.SetType (WIFI_MAC_MGT_ACTION);
   hdr.SetAddr1 (addr);
   hdr.SetAddr2 (m_low->GetAddress ());
-  hdr.SetAddr3 (m_low->GetAddress ());
+  hdr.SetAddr3 (m_low->GetBssid ());
   hdr.SetDsNotTo ();
   hdr.SetDsNotFrom ();
 
@@ -1700,9 +1681,7 @@
   NS_LOG_FUNCTION (this);
   ResetCw ();
   m_cwTrace = GetCw ();
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
 }
 
 void
@@ -1734,9 +1713,7 @@
     {
       m_baManager->NotifyAgreementNoReply (recipient, tid);
       Simulator::Schedule (m_failedAddBaTimeout, &QosTxop::ResetBa, this, recipient, tid);
-      m_backoff = m_rng->GetInteger (0, GetCw ());
-      m_backoffTrace (m_backoff);
-      StartBackoffNow (m_backoff);
+      GenerateBackoff ();
       RestartAccessIfNeeded ();
     }
 }
@@ -1745,7 +1722,12 @@
 QosTxop::ResetBa (Mac48Address recipient, uint8_t tid)
 {
   NS_LOG_FUNCTION (this << recipient << +tid);
-  if (!m_baManager->ExistsAgreementInState (recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
+  // This function is scheduled when waiting for an ADDBA response. However,
+  // before this function is called, a DELBA request may arrive, which causes
+  // the agreement to be deleted. Hence, check if an agreement exists before
+  // notifying that the agreement has to be reset.
+  if (m_baManager->ExistsAgreement (recipient, tid)
+      && !m_baManager->ExistsAgreementInState (recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
     {
       m_baManager->NotifyAgreementReset (recipient, tid);
     }
